/*
 * Host AP (software wireless LAN access point) user space daemon for
 * Host AP kernel driver / IEEE 802.11f Inter-Access Point Protocol (IAPP)
 * Copyright (c) 2002, Jouni Malinen <jkmaline@cc.hut.fi>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation. See README and COPYING for
 * more details.
 */

/* TODO:
 * - implement IAPP-ADD and Level 2 Update sending
 * - add support for MOVE-notify and MOVE-response (this requires support for
 *   finding out IP address for previous AP using RADIUS)
 * - add support for Send- and ACK-Security-Block to speedup IEEE 802.1X during
 *   reassociation to another AP
 * - implement counters etc. for IAPP MIB
 */

#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>
#include <net/if.h>
#include <linux/if_ether.h>

#include "hostapd.h"
#include "ieee802_11.h"
#include "iapp.h"


void iapp_new_station(hostapd *hapd, struct sta_info *sta)
{
	struct ieee80211_mgmt *assoc;

	/* Send IAPP-ADD Packet */
	/* Send Level 2 Update Frame */

	assoc = sta->last_assoc_req;
	if (assoc && WLAN_FC_GET_STYPE(le_to_host16(assoc->frame_control))) {
		/* Send IAPP-MOVE to old AP */
	}
}


void iapp_receive_udp(hostapd *hapd, char *buf, int len)
{
	/* Handle incoming IAPP frames (over UDP/IP) */

	/* Remove station info if another AP is sending an IAPP-ADD PAcket for
	 * a station that is associated with this AP. */
}
